# 1 "EDITOR.A"
APPLICATION EDITOR;

USES
        HTML, TextFile

       , XML





       , Annot
       , XLink

       , MathML

       , SVG

       , TableH;

DEFAULT
   BEGIN
        Init.Post -> InitAmaya;
        DocClose.Post -> DocumentClosed;
        DocSave.Pre -> DocumentToSave;
        ViewClose.Pre -> ViewToClose;
   END;

MENUS
   Document Windows:
        BEGIN
        view:1 File.New1 button:BHtml11 -> NewXHTML11;
        view:1 File.New1 button:BHtmlTransitional -> NewXHTMLTransitional;
        view:1 File.New1 button:BHtmlStrict -> NewXHTMLStrict;
        view:1 File.New1 button:BHtmlBasic -> NewXHTMLBasic;
        view:1 File.New1 Separator;
        view:1 File.New1 button:BMathml -> NewMathML;
        view:1 File.New1 button:BSvg -> NewSVG;
        view:1 File.New1 button:BCss -> NewCss;
        view:1 File.New1 button:BTemplate -> NewTemplate;

        view:1 File button:BOpenDoc -> OpenDoc;
        view:1 File button:BOpenInNewWindow -> OpenDocInNewWindow;
        view:1 File button:BReload -> Reload;
        view:1 File button:BBack -> GotoPreviousHTML;
        view:1 File button:BForward -> GotoNextHTML;
        view:1 File button:BSave -> SaveDocument;
        view:1 File button:BSaveAs -> SaveDocumentAs;
        view:1 File Separator;
        view:1 File button:BSynchro -> Synchronize;
        view:1 File.Doctype1 button:BRemoveDoctype -> RemoveDoctype;
        view:1 File.Doctype1 Separator;
        view:1 File.Doctype1 button:BDoctypeXhtml11 -> CreateDoctypeHtml11;
        view:1 File.Doctype1 button:BDoctypeXhtmlTransitional -> CreateDoctypeHtmlTransitional;
        view:1 File.Doctype1 button:BDoctypeXhtmlStrict -> CreateDoctypeHtmlStrict;
        view:1 File.Doctype1 button:BDoctypeXhtmlBasic -> CreateDoctypeHtmlBasic;
        view:1 File.Doctype1 button:BDoctypeHtmlTransitional -> CreateDoctypeHtmlTransitional;
        view:1 File.Doctype1 button:BDoctypeHtmlStrict -> CreateDoctypeHtmlStrict;
        view:1 File.Doctype1 Separator;
        view:1 File.Doctype1 button:BDoctypeXhtmlPlusMath -> CreateDoctypeHtml11;
        view:1 File.Doctype1 button:BDoctypeMathML -> CreateDoctypeMathML;
        view:1 File.Doctype1 button:BDoctypeSVG -> CreateDoctypeSVG;
        view:1 File button:BDocInfo -> DocumentInfo;
        view:1 File Separator;
        view:1 File button:BSetUpandPrint -> SetupAndPrint;
        view:1 File button:BPrint -> PrintAs;
        view:1 File Separator;
        view:1 File button:BClose -> CloseDocument;
        view:1 File button:BExit -> AmayaClose;

        view:2 File2 button:BCloseView -> TtcCloseView;
        view:3 File3 button:BCloseView -> TtcCloseView;
        view:4 File4 button:BCloseView -> TtcCloseView;
        view:5 File5 button:BCloseView -> TtcCloseView;

        Edit_ button:BUndo -> TtcUndo;
        Edit_ button:BRedo -> TtcRedo;
        Edit_ Separator;
        Edit_ button:BCut -> TtcCutSelection;
        Edit_ button:BCopy -> TtcCopySelection;
        Edit_ button:BPaste -> TtcPaste;
        Edit_ button:BClear -> TtcDeleteSelection;
        Edit_ Separator;
        Edit_ toggle:TEditMode -> SetBrowserEditor;
        Edit_ button:BFind -> TtcSearchText;
        Edit_ button:BSpellCheck -> SpellCheck;
        Edit_ button:BTransform -> TransformType;

        view:2 StructTypes button:BBase -> CreateBase;
        view:2 StructTypes button:BMeta -> CreateMeta;
        view:2 StructTypes button:BLink -> CreateLinkInHead;
        view:2 StructTypes button:BScript -> CreateScript;
        view:2 StructTypes button:BStyle -> CreateStyle;
        view:2 StructTypes button:BComment -> CreateComment;

        Types button:BTitle -> ChangeTitle;
        Types Separator;
        Types button:BAddress -> CreateAddress;
        Types.AreaMap button:BCircle -> CreateAreaCircle;
        Types.AreaMap button:BPoly -> CreateAreaPoly;
        Types.AreaMap button:BRectangle -> CreateAreaRect;

        Types button:BBlockQuote -> CreateBlockQuote;
        Types button:BBreak -> CreateBreak;
        Types button:BDivision -> CreateDivision;

        Types.Form button:BForm -> CreateForm;
        Types.Form Separator;
        Types.Form button:BPushButton -> CreatePushButton;
        Types.Form button:BToggle -> CreateToggle;
        Types.Form button:BFileInput -> CreateFileInput;
        Types.Form button:BHiddenInput -> CreateHiddenInput;
        Types.Form button:BImageInput -> CreateImageInput;
        Types.Form button:BPasswordInput -> CreatePasswordInput;
        Types.Form button:BRadio -> CreateRadio;
        Types.Form button:BReset -> CreateReset;
        Types.Form button:BSubmit -> CreateSubmit;
        Types.Form button:BTextInput -> CreateTextInput;
        Types.Form button:BFieldset -> CreateFieldset;
        Types.Form button:BLabel -> CreateLabel;
        Types.Form button:BOption -> CreateOption;
        Types.Form button:BOptionGroup -> CreateOptGroup;
        Types.Form button:BTextArea -> CreateTextArea;

        Types.Heading button:BH1 -> CreateHeading1;
        Types.Heading button:BH2 -> CreateHeading2;
        Types.Heading button:BH3 -> CreateHeading3;
        Types.Heading button:BH4 -> CreateHeading4;
        Types.Heading button:BH5 -> CreateHeading5;
        Types.Heading button:BH6 -> CreateHeading6;

        Types button:BRule -> CreateHorizontalRule;
        Types button:BIFrame -> CreateIFrame;
        Types button:BImage -> CreateImage;

        Types.Lists button:BBulletedList -> CreateList;
        Types.Lists button:BNumberedList -> CreateNumberedList;
        Types.Lists button:BDefinitionList -> CreateDefinitionList;
        Types.Lists Separator;
        Types.Lists button:BTerm -> CreateDefinitionTerm;
        Types.Lists button:BDefinition -> CreateDefinitionDef;

        Types.Math button:BDisplayMath -> CreateMath;
        Types.Math Separator;
        Types.Math button:BMText -> CreateMTEXT;
        Types.Math button:BMIdentifier -> CreateMI;
        Types.Math button:BMNumber -> CreateMN;
        Types.Math button:BMOperator -> CreateMO;
        Types.Math button:BMSpace -> CreateMSPACE;
        Types.Math button:BMEntity -> CreateMathEntity;
        Types.Math button:BMInvisibleTimes -> CreateInvisibleTimes;
        Types.Math button:BMApplyFunction -> CreateApplyFunction;
        Types.Math Separator;
        Types.Math button:BNthRoot -> CreateMROOT;
        Types.Math button:BSquareRoot -> CreateMSQRT;
        Types.Math button:BEnclose -> CreateMENCLOSE;
        Types.Math button:BFraction -> CreateMFRAC;
        Types.Math button:BSubscriptAndSuperscript -> CreateMSUBSUP;
        Types.Math button:BSubscript -> CreateMSUB;
        Types.Math button:BSuperscript -> CreateMSUP;
        Types.Math button:BUnderAndOver -> CreateMUNDEROVER;
        Types.Math button:BUnder -> CreateMUNDER;
        Types.Math button:BOver -> CreateMOVER;
        Types.Math button:BParentheses -> CreateMROW;
        Types.Math button:BMultiscripts -> CreateMMULTISCRIPTS;
        Types.Math button:BMatrix -> CreateMTABLE;
        Types.Math Separator;
        Types.Math button:BDeleteMColumn -> DeleteMColumn;

        Types button:BNoScript -> CreateNOSCRIPT;

        Types.Object button:BObject -> CreateObject;
        Types.Object button:BParameter -> CreateParameter;

        Types button:BParagraph -> CreateParagraph;
        Types button:BPreformatted -> CreatePreformatted;
        Types button:BRuby -> CreateRuby;

        Types.Table button:BTable -> CreateTable;
        Types.Table Separator;
        Types.Table button:BCaption -> CreateCaption;
        Types.Table button:BColgroup -> CreateColgroup;
        Types.Table button:BCol -> CreateCol;
        Types.Table button:BTHead -> CreateTHead;
        Types.Table button:BTBody -> CreateTBody;
        Types.Table button:BTFoot -> CreateTFoot;
        Types.Table button:BRow -> CreateRow;
        Types.Table button:BDataCell -> CreateDataCell;
        Types.Table button:BHeadingCell -> CreateHeadingCell;
        Types.Table Separator;
        Types.Table button:BDeleteColumn -> DeleteColumn;

        view:1 Links button:BLinkTarget -> LinkToPreviousTarget;
        view:1 Links button:BCreateLink -> CreateOrChangeLink;
        view:1 Links button:BCreateTarget -> CreateTarget;
        view:1 Links button:BDeleteAnchor -> DeleteAnchor;
        view:1 Links button:BMemorizeXPtr -> XPointer_bufferStore;

        view:1 Views toggle:TShowButtonbar -> TtcSwitchButtonBar;
        view:1 Views toggle:TShowTextZone -> TtcSwitchCommands;
        view:1 Views toggle:TShowMapAreas -> ShowMapAreas;
        view:1 Views toggle:TShowTargets -> ShowTargets;
        view:1 Views toggle:TZoomIn -> ZoomIn;
        view:1 Views toggle:TZoomOut -> ZoomOut;
        view:1 Views Separator;
        view:1 Views button:BShowLogFile -> ShowLogFile;
        view:1 Views button:BShowStructure -> ShowStructure;
        view:1 Views button:BShowAlternate -> ShowAlternate;
        view:1 Views button:BShowLinks -> ShowLinks;
        view:1 Views button:BShowToC -> ShowToC;
        view:1 Views button:BShowSource -> ShowSource;

        view:1 Style button:BCharacterStyle -> TtcChangeCharacters;
        view:1 Style button:BColors -> TtcChangeColors;
        view:1 Style button:BFormat -> TtcChangeFormat;
        view:1 Style button:BBackgroundImage -> ChangeBackgroundImage;
        view:1 Style Separator;

        view:1 Style button:BCreateClass -> CreateClass;
        view:1 Style button:BApplyClass -> ApplyClass;
        view:1 Style.StyleSheet button:BLinkCSS -> LinkCSS;
        view:1 Style.StyleSheet button:BOpenCSS -> OpenCSS;
        view:1 Style.StyleSheet button:BDisableCSS -> DisableCSS;
        view:1 Style.StyleSheet button:BEnableCSS -> EnableCSS;
        view:1 Style.StyleSheet button:BRemoveCSS -> RemoveCSS;
        view:1 Style Separator;
        view:1 Style.Phrase toggle:TEmphasis -> SetOnOffEmphasis;
        view:1 Style.Phrase toggle:TStrong -> SetOnOffStrong;
        view:1 Style.Phrase toggle:TCite -> SetOnOffCite;
        view:1 Style.Phrase toggle:TDefinition -> SetOnOffDefinition;
        view:1 Style.Phrase toggle:TCode -> SetOnOffCode;
        view:1 Style.Phrase toggle:TVariable -> SetOnOffVariable;
        view:1 Style.Phrase toggle:TSample -> SetOnOffSample;
        view:1 Style.Phrase toggle:TKeyboard -> SetOnOffKeyboard;
        view:1 Style.Phrase toggle:TAbbreviation -> SetOnOffAbbr;
        view:1 Style.Phrase toggle:TAcronym -> SetOnOffAcronym;
        view:1 Style.Phrase toggle:TInsertion -> SetOnOffINS;
        view:1 Style.Phrase toggle:TDeletion -> SetOnOffDEL;

        view:1 Style.Font toggle:TItalic -> SetOnOffItalic;
        view:1 Style.Font toggle:TBold -> SetOnOffBold;
        view:1 Style.Font toggle:TTeletype -> SetOnOffTeletype;
        view:1 Style.Font toggle:TBig -> SetOnOffBig;
        view:1 Style.Font toggle:TSmall -> SetOnOffSmall;
        view:1 Style.Font toggle:TSub -> SetOnOffSub;
        view:1 Style.Font toggle:TSup -> SetOnOffSup;
        view:1 Style.Font toggle:TQuotation -> SetOnOffQuotation;
        view:1 Style.Font toggle:TBDO -> SetOnOffBDO;

        view:1 Special toggle:TSectionNumber -> SectionNumbering;
        view:1 Special button:BMakeBook -> MakeBook;
        view:1 Special button:BMakeID -> MakeIDMenu;
        view:1 Special Separator;
        view:1 Special.Coptions button:BConfigGeneral -> ConfigGeneral;
        view:1 Special.Coptions button:BConfigPublish -> ConfigPublish;
        view:1 Special.Coptions button:BConfigCache -> ConfigCache;
        view:1 Special.Coptions button:BConfigProxy -> ConfigProxy;
        view:1 Special.Coptions button:BConfigColor -> ConfigColor;
        view:1 Special.Coptions button:BConfigGeometry -> ConfigGeometry;
        view:1 Special.Coptions button:BConfigLanNeg -> ConfigLanNeg;
        view:1 Special.Coptions button:BConfigProfile -> ConfigProfile;
        view:1 Special.Coptions button:BConfigTemplates -> ConfigTemplates;



        Attributes_;

        view:1 Annotations_ button:BAnnotateSelection -> AnnotateSelection;
        view:1 Annotations_ button:BAnnotateDocument -> AnnotateDocument;
        view:1 Annotations_ button:BMoveAnnotSel -> MoveAnnotationSel;
        view:1 Annotations_ button:BMoveAnnotXPtr -> MoveAnnotationXPtr;
        Annotations_ Separator;
        view:1 Annotations_ button:BReplyToAnnotation -> ReplyToAnnotation;
        Annotations_ Separator;
        view:1 Annotations_ button:BPostAnnot -> PostAnnotation;
        view:1 Annotations_ button:BDeleteAnnot -> DeleteAnnotation;
        view:1 Annotations_ button:BLoadAnnotations -> LoadAnnotations;
        Annotations_ Separator;
        view:1 Annotations_ button:BCustomQuery -> CustomQuery;
        view:1 Annotations_ button:BFilterAnnotations -> FilterAnnot;
        Annotations_ Separator;
        view:1 Annotations_ button:BConfigAnnotations -> ConfigAnnot;

        view:1 Cooperation_ button:BLock -> LockDocument;
        view:1 Cooperation_ button:BUnlock -> UnlockDocument;
        view:1 Cooperation_ button:BProp -> PropDocument;
        view:1 Cooperation_ Separator;
        view:1 Cooperation_ toggle:BLockIndicator -> LockIndicator;

        view:1 Help_ button:BInformation -> HelpAmaya;
        view:1 Help_ button:BAtW3C -> HelpAtW3C;
        view:1 Help_ button:BHelpIndex -> HelpIndex;
        view:1 Help_ Separator;
        view:1 Help_ button:BHelpBrowsing -> HelpBrowsing;
        view:1 Help_ button:BHelpViews -> HelpViews;
        view:1 Help_ button:BHelpSelecting -> HelpSelecting;
        view:1 Help_ button:BHelpDocument -> HelpDocument;
        view:1 Help_ button:BHelpCreating -> HelpCreating;
        view:1 Help_ button:BHelpAttributes -> HelpAttributes;
        view:1 Help_ button:BHelpText -> HelpEditChar;
        view:1 Help_ button:BHelpChanging -> HelpChanging;
        view:1 Help_ button:BHelpLinks -> HelpLinks;
        view:1 Help_ button:BHelpTables -> HelpTables;
        view:1 Help_ button:BHelpImageMaps -> HelpImageMaps;
        view:1 Help_ button:BHelpMath -> HelpMath;
        view:1 Help_ button:BHelpSVG -> HelpSVG;
        view:1 Help_ button:BHelpXml -> HelpXml;
        view:1 Help_ button:BHelpStyleSheets -> HelpStyleSheets;
        view:1 Help_ button:BSearching -> HelpSearching;
        view:1 Help_ button:BHelpSpellChecking -> HelpSpellChecking;
        view:1 Help_ button:BHelpPublishing -> HelpPublishing;
        view:1 Help_ button:BHelpPrinting -> HelpPrinting;
        view:1 Help_ button:BHelpNumbering -> HelpNumbering;
        view:1 Help_ button:BHelpMakeBook -> HelpMakeBook;
        view:1 Help_ button:BHelpAnnotation -> HelpAnnotation;
        view:1 Help_ button:BHelpConfigure -> HelpConfigure;
        view:1 Help_ button:BHelpShortCuts -> HelpShortCuts;
        view:1 Help_ button:BHelpAccess -> HelpAccess;
        END;

FUNCTIONS
  DoAction,
  NextLinkOrFormElement,
  PreviousLinkOrFormElement,
  StopTransfer,
  GoToHome;
END
