# 1 "HTML.A"
APPLICATION HTML;

DEFAULT
   BEGIN
        ElemActivate.Pre -> DoubleClick;
        ElemClick.Pre -> SimpleClick;
        ElemRClick.Pre -> SimpleRClick;
        ElemPaste.Post -> ElementPasted;
        ElemNew.Post -> ElementCreated;
        ElemDelete.Post -> ElementDeleted;
        ElemSelect.Post -> SelectionChanged;
        ElemExtendSelect.Post -> SelectionChanged;
        AttrMenu.Pre -> GlobalAttrInMenu;
        PRuleCreate.Pre -> ChangePRule;
        PRuleModify.Pre -> ChangePRule;
        PRuleDelete.Post -> PRuleDeleted;
   END;

ELEMENTS

   PICTURE_UNIT:
        BEGIN
        ElemNew.Post -> UpdateSRCattribute;
        ElemTextModify.Post -> UpdateSRCattribute;
        ElemSelect.Pre -> SelectPicture;
        ElemDelete.Pre -> DeletePicture;
        END;

   TEXT_UNIT:
        ElemTextModify.Post -> CheckNewLines;

   LINK:
        BEGIN
        ElemDelete.Pre -> DeleteLink;
        END;

   MAP:
        BEGIN
        ElemDelete.Pre -> DeleteMap;
        END;

   Text_Input:
        BEGIN
        ElemTextModify.Pre -> SaveDocumentStatus;
        ElemTextModify.Post -> RestoreDocumentStatus;
        ElemReturn.Pre -> HandleReturn;
        END;

   Password_Input:
        BEGIN
        ElemTextModify.Pre -> SaveDocumentStatus;
        ElemTextModify.Post -> RestoreDocumentStatus;
        ElemReturn.Pre -> HandleReturn;
        END;

   Text_Area:
        BEGIN
        ElemTextModify.Pre -> SaveDocumentStatus;
        ElemTextModify.Post -> RestoreDocumentStatus;
        END;

   File_Input:
        BEGIN
        ElemTextModify.Pre -> SaveDocumentStatus;
        ElemTextModify.Post -> RestoreDocumentStatus;
        ElemReturn.Pre -> HandleReturn;
        END;

   STYLE_:
        BEGIN
        ElemTab.Pre -> AcceptTab;
        END;

   SCRIPT_:
        BEGIN
        ElemTab.Pre -> AcceptTab;
        END;

   Frame:
        ElemSelect.Pre -> SelectInsertedText;

   TITLE:
        ElemTextModify.Post -> TitleModified;

   Table:
        ElemNew.Post -> TableCreated;

   Table_body:
        ElemDelete.Post -> TablebodyDeleted;

   Data_cell:
        BEGIN
        ElemNew.Post -> CellCreated;
        ElemPaste.Post -> CellPasted;
        ElemDelete.Pre -> DeleteCell;
        ElemDelete.Post -> CellDeleted;
        END;

   Heading_cell:
        BEGIN
        ElemNew.Post -> CellCreated;
        ElemPaste.Post -> CellPasted;
        ElemDelete.Pre -> DeleteCell;
        ElemDelete.Post -> CellDeleted;
        END;

   Table_row:
        BEGIN
        ElemNew.Post -> RowCreated;
        ElemPaste.Post -> RowPasted;
        ElemDelete.Pre -> DeleteRow;
        ElemDelete.Post -> RowDeleted;
        END;

   STYLE_:
        BEGIN
        ElemTextModify.Pre -> ChangeStyle;
        ElemTextModify.Post -> StyleChanged;
        ElemDelete.Pre -> DeleteStyle;
        END;

   META:
        BEGIN
        ElemExport.Pre -> CheckGenerator;
        END;

   List_Item:
        BEGIN
        ElemNew.Post -> ListItemCreated;
        ElemPaste.Post -> ListItemCreated;
        END;

   Unnumbered_List:
        ElemChange.Post -> ListChangedType;

   Numbered_List:
        ElemChange.Post -> ListChangedType;

ATTRIBUTES

   SRC:
        BEGIN
        AttrModify.Post -> SRCattrModified;
        END;
   coords:
        BEGIN
        AttrModify.Post -> CoordsModified;
        END;

   x_coord:
        BEGIN
        AttrModify.Post -> GraphicsModified;
        END;

   y_coord:
        BEGIN
        AttrModify.Post -> GraphicsModified;
        END;

   Width__:
        BEGIN
        AttrCreate.Pre -> StoreWidth;
        AttrCreate.Post -> AttrWidthModified;
        AttrModify.Pre -> StoreWidth;
        AttrModify.Post -> AttrWidthModified;
        AttrDelete.Pre -> AttrWidthDelete;
        END;

   IntWidthPxl:
        BEGIN
        AttrModify.Pre -> StoreWidth;
        AttrModify.Post -> GraphicsModified;
        END;

   Height_:
        BEGIN
        AttrCreate.Pre -> StoreHeight;
        AttrCreate.Post -> GraphicsModified;
        AttrModify.Pre -> StoreHeight;
        AttrModify.Post -> AttrHeightModified;
        AttrDelete.Pre -> AttrHeightDelete;
        END;

   IntHeightPxl:
        BEGIN
        AttrModify.Pre -> StoreHeight;
        AttrModify.Post -> GraphicsModified;
        END;

   colspan_:
        BEGIN
        AttrCreate.Post -> ColspanCreated;
        AttrModify.Pre -> RegisterColspan;
        AttrModify.Post -> ColspanModified;
        AttrDelete.Pre -> RegisterColspan;
        AttrDelete.Post -> ColspanDeleted;
        END;

   rowspan_:
        BEGIN
        AttrCreate.Post -> RowspanCreated;
        AttrModify.Pre -> RegisterRowspan;
        AttrModify.Post -> RowspanModified;
        AttrDelete.Pre -> RegisterRowspan;
        AttrDelete.Post -> RowspanDeleted;
        END;

   NAME:
        BEGIN
        AttrMenu.Pre -> AttrNAMEinMenu;
        AttrExport.Pre -> CheckValidID;
        END;

   Font_size:
        BEGIN
        AttrCreate.Post -> AttrFontSizeCreated;
        AttrModify.Post -> AttrFontSizeCreated;
        AttrDelete.Pre -> AttrFontSizeDelete;
        END;

   color:
        BEGIN
        AttrCreate.Post -> AttrColorCreated;
        AttrModify.Post -> AttrColorCreated;
        AttrDelete.Pre -> AttrColorDelete;
        END;

   TextColor:
        BEGIN
        AttrCreate.Post -> AttrColorCreated;
        AttrModify.Post -> AttrColorCreated;
        AttrDelete.Pre -> AttrColorDelete;
        END;
   BackgroundColor:
        BEGIN
        AttrCreate.Post -> AttrColorCreated;
        AttrModify.Post -> AttrColorCreated;
        AttrDelete.Pre -> AttrColorDelete;
        END;
   background_:
        BEGIN
        AttrCreate.Post -> AttrColorCreated;
        AttrModify.Post -> AttrColorCreated;
        AttrDelete.Pre -> AttrColorDelete;
        END;
   LinkColor:
        BEGIN
        AttrCreate.Post -> AttrColorCreated;
        AttrModify.Post -> AttrColorCreated;
        AttrDelete.Pre -> AttrColorDelete;
        END;
   VisitedLinkColor:
        BEGIN
        AttrCreate.Post -> AttrColorCreated;
        AttrModify.Post -> AttrColorCreated;
        AttrDelete.Pre -> AttrColorDelete;
        END;
   ActiveLinkColor:
        BEGIN
        AttrCreate.Post -> AttrColorCreated;
        AttrModify.Post -> AttrColorCreated;
        AttrDelete.Pre -> AttrColorDelete;
        END;

   BulletStyle:
        BEGIN
        AttrCreate.Post -> UpdateAttrIntItemStyle;
        AttrModify.Post -> UpdateAttrIntItemStyle;
        AttrDelete.Post -> UpdateAttrIntItemStyle;
        END;

   NumberStyle:
        BEGIN
        AttrCreate.Post -> UpdateAttrIntItemStyle;
        AttrModify.Post -> UpdateAttrIntItemStyle;
        AttrDelete.Post -> UpdateAttrIntItemStyle;
        END;

   ItemStyle:
        BEGIN
        AttrCreate.Post -> AttrItemStyle;
        AttrModify.Post -> AttrItemStyle;
        AttrDelete.Post -> AttrItemStyle;
        END;

   Language:
        BEGIN
        AttrCreate.Post -> AttrLangCreated;
        AttrDelete.Pre -> AttrLangShouldBeDeleted;
        AttrDelete.Post -> AttrLangDeleted;
        AttrModify.Post -> AttrLangModified;
        END;

   ID:
        BEGIN
        AttrCreate.Post -> UpdateAttrID;
        AttrModify.Post -> UpdateAttrID;
        AttrDelete.Post -> UpdateAttrID;
        END;

   Class:
        BEGIN
        AttrCreate.Post -> AttrClassChanged;
        AttrModify.Post -> AttrClassChanged;
        AttrDelete.Post -> AttrClassChanged;
        END;

   Style\240:
        BEGIN
        AttrCreate.Post -> UpdateStylePost;
        AttrModify.Pre -> UpdateStyleDelete;
        AttrModify.Post -> UpdateStylePost;
        AttrDelete.Pre -> UpdateStyleDelete;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;
   media:
        BEGIN
        AttrCreate.Post -> AttrMediaChanged;
        AttrModify.Post -> AttrMediaChanged;
        AttrDelete.Post -> AttrMediaChanged;
        END;

   Title:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;

   dir:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;

   onclick:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;
   ondblclick:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;
   onmousedown:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;
   onmouseup:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;
   onmouseover:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;
   onmousemove:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;
   onmouseout:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;
   onkeypress:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;
   onkeydown:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;
   onkeyup:
        BEGIN
        AttrCreate.Post -> GlobalAttrCreated;
        AttrDelete.Post -> GlobalAttrDeleted;
        END;

   Selected:
        BEGIN
        AttrCreate.Post -> UpdateAttrSelected;
        AttrModify.Post -> UpdateAttrSelected;
        AttrDelete.Post -> AttrSelectedDeleted;
        END;

   Multiple:
        AttrDelete.Post -> UpdateAttrSelected;

   Checked:
        BEGIN
        AttrDelete.Pre -> DeleteAttrSelected;
        END;

   Style\240:
        BEGIN
        AttrExport.Pre -> GenerateQuoteBefore;
        AttrExport.Post -> GenerateQuoteAfter;
        END;

   meta_content:
        BEGIN
        AttrExport.Pre -> GenerateQuoteBefore;
        AttrExport.Post -> GenerateQuoteAfter;
        END;

   accesskey:
        BEGIN
        AttrCreate.Post -> AddAccessKey;
        AttrModify.Pre -> RemoveAccessKey;
        AttrModify.Post -> AddAccessKey;
        AttrDelete.Pre -> RemoveAccessKey;
        END;

END
