# 1 "SVG.A"
APPLICATION SVG;

DEFAULT
   BEGIN
        ElemActivate.Pre -> DoubleClick;
        ElemClick.Pre -> SimpleClick;
        ElemRClick.Pre -> SimpleRClick;
        ElemPaste.Post -> GraphElemPasted;
        AttrMenu.Pre -> GlobalSVGAttrInMenu;
        PRuleCreate.Pre -> GraphicsPRuleChange;
        PRuleModify.Pre -> GraphicsPRuleChange;
        ElemSelect.Post -> GraphicsSelectionChanged;
        ElemExtendSelect.Pre -> ExtendSelectSVGElement;
   END;

ELEMENTS

   SVG:
        BEGIN
        ElemNew.Post -> SVGCreated;
        ElemExport.Pre -> SetEmptyShapeAttribute;
        END;
{*** Only for SVG "animation" demo. See end of file Graphedit.c ***
   g:
        BEGIN
        ElemTextModify.Pre -> TextWillChangeInGroup;
        ElemTextModify.Post -> TextChangedInGroup;
        END;
***}
   rect:
        ElemGraphModify.Post -> GraphicsChanged;
   circle:
        ElemGraphModify.Post -> GraphicsChanged;
   ellipse:
        ElemGraphModify.Post -> GraphicsChanged;
   polyline:
        ElemGraphModify.Post -> ControlPointChanged;
   polygon:
        ElemGraphModify.Post -> ControlPointChanged;
   tspan:
        BEGIN
        ElemNew.Post -> TspanCreated;
        ElemPaste.Post -> TspanCreated;
        END;
   use_:
        ElemPaste.Post -> UsePasted;
   image:
        ElemNew.Post -> SvgImageCreated;
   style__:
        BEGIN
        ElemTextModify.Pre -> ChangeStyle;
        ElemTextModify.Post -> StyleChanged;
        ElemDelete.Pre -> DeleteStyle;
        END;
   foreignObject:
        BEGIN
        ElemExport.Pre -> ExportForeignObject;
        ElemGraphModify.Post -> GraphicsChanged;
        END;

   GRAPHICS_UNIT:
        ElemDelete.Post -> GraphLeafDeleted;
   PICTURE_UNIT:
        ElemPaste.Pre -> PastePicture;

ATTRIBUTES

   Language:
        BEGIN
        AttrCreate.Post -> AttrLangCreated;
        AttrDelete.Pre -> AttrLangShouldBeDeleted;
        AttrDelete.Post -> AttrLangDeleted;
        AttrModify.Post -> AttrLangModified;
        END;

   id:
        BEGIN
        AttrCreate.Post -> UpdateAttrID;
        AttrModify.Post -> UpdateAttrID;
        AttrDelete.Post -> UpdateAttrID;
        END;

   class:
        BEGIN
        AttrCreate.Post -> AttrClassChanged;
        AttrModify.Post -> AttrClassChanged;
        AttrDelete.Post -> AttrClassChanged;
        END;

   style_:
        BEGIN
        AttrDelete.Pre -> UpdateStyleDelete;
        AttrModify.Pre -> UpdateStyleDelete;
        AttrCreate.Post -> UpdateStylePost;
        AttrModify.Post -> UpdateStylePost;
        END;

   Namespace:
        AttrExport.Post -> NameSpaceGenerated;

   height_:
        BEGIN
        AttrModify.Post -> AttrWidthHeightChanged;
        AttrDelete.Pre -> AttrWidthHeightDelete;
        END;
   width_:
        BEGIN
        AttrModify.Post -> AttrWidthHeightChanged;
        AttrDelete.Pre -> AttrWidthHeightDelete;
        END;
   font_family:
        BEGIN
        AttrModify.Post -> AttrCSSequivModified;
        AttrCreate.Post -> AttrCSSequivModified;
        AttrDelete.Pre -> AttrCSSequivDelete;
        END;
   font_size:
        BEGIN
        AttrModify.Post -> AttrCSSequivModified;
        AttrCreate.Post -> AttrCSSequivModified;
        AttrDelete.Pre -> AttrCSSequivDelete;
        END;
   font_style:
        BEGIN
        AttrModify.Post -> AttrCSSequivModified;
        AttrCreate.Post -> AttrCSSequivModified;
        AttrDelete.Pre -> AttrCSSequivDelete;
        END;
   font_variant:
        BEGIN
        AttrModify.Post -> AttrCSSequivModified;
        AttrCreate.Post -> AttrCSSequivModified;
        AttrDelete.Pre -> AttrCSSequivDelete;
        END;
   font_weight:
        BEGIN
        AttrModify.Post -> AttrCSSequivModified;
        AttrCreate.Post -> AttrCSSequivModified;
        AttrDelete.Pre -> AttrCSSequivDelete;
        END;
   text_anchor:
        BEGIN
        AttrModify.Post -> AttrTextAnchorModified;
        AttrCreate.Post -> AttrTextAnchorModified;
        AttrDelete.Pre -> AttrTextAnchorDelete;
        END;
   text_decoration:
        BEGIN
        AttrModify.Post -> AttrCSSequivModified;
        AttrCreate.Post -> AttrCSSequivModified;
        AttrDelete.Pre -> AttrCSSequivDelete;
        END;
   fill:
        BEGIN
        AttrModify.Post -> AttrCSSequivModified;
        AttrCreate.Post -> AttrCSSequivModified;
        AttrDelete.Pre -> AttrCSSequivDelete;
        END;
   stroke:
        BEGIN
        AttrModify.Post -> AttrCSSequivModified;
        AttrCreate.Post -> AttrCSSequivModified;
        AttrDelete.Pre -> AttrCSSequivDelete;
        END;
   stroke_width:
        BEGIN
        AttrModify.Post -> AttrCSSequivModified;
        AttrCreate.Post -> AttrCSSequivModified;
        AttrDelete.Pre -> AttrCSSequivDelete;
        END;

   requiredFeatures:
        BEGIN
        AttrModify.Post -> EvaluateSwitch;
        AttrCreate.Post -> EvaluateSwitch;
        AttrDelete.Post -> EvaluateSwitch;
        END;
   requiredExtensions:
        BEGIN
        AttrModify.Post -> EvaluateSwitch;
        AttrCreate.Post -> EvaluateSwitch;
        AttrDelete.Post -> EvaluateSwitch;
        END;
   systemLanguage:
        BEGIN
        AttrModify.Post -> EvaluateSwitch;
        AttrCreate.Post -> EvaluateSwitch;
        AttrDelete.Post -> EvaluateSwitch;
        END;

   transform:
        BEGIN
        AttrModify.Post -> AttrTransformChanged;
        AttrCreate.Post -> AttrTransformChanged;
        AttrDelete.Pre -> AttrTransformDelete;
        END;
   d:
        BEGIN
        AttrModify.Post -> AttrPathDataChanged;
        AttrDelete.Pre -> AttrPathDataDelete;
        END;
   x:
        AttrModify.Post -> AttrCoordChanged;
   y:
        AttrModify.Post -> AttrCoordChanged;
   cx:
        AttrModify.Post -> AttrCoordChanged;
   cy:
        AttrModify.Post -> AttrCoordChanged;
   r:
        BEGIN
        AttrModify.Post -> AttrWidthHeightChanged;
        AttrDelete.Pre -> AttrWidthHeightDelete;
        END;
   rx:
        BEGIN
        AttrModify.Post -> AttrWidthHeightChanged;
        AttrCreate.Post -> AttrWidthHeightChanged;
        AttrDelete.Pre -> AttrWidthHeightDelete;
        END;
   ry:
        BEGIN
        AttrModify.Post -> AttrWidthHeightChanged;
        AttrCreate.Post -> AttrWidthHeightChanged;
        AttrDelete.Pre -> AttrWidthHeightDelete;
        END;
   x1:
        AttrModify.Post -> AttrCoordChanged;
   y1:
        AttrModify.Post -> AttrCoordChanged;
   x2:
        AttrModify.Post -> AttrCoordChanged;
   y2:
        AttrModify.Post -> AttrCoordChanged;
   points:
        BEGIN
        AttrDelete.Pre -> DeleteAttrPoints;
        AttrModify.Post -> AttrPointsModified;
        END;
   dx:
        AttrModify.Post -> AttrCoordChanged;
   dy:
        AttrModify.Post -> AttrCoordChanged;
   xlink_href:
        BEGIN
        AttrModify.Pre -> AttrXlinkHrefWillBeChanged;
        AttrModify.Post -> AttrXlinkHrefChanged;
        AttrDelete.Pre -> DeleteAttrXlinkHref;
        END;
END
